﻿R — язык программирования для статистической обработки данных и работы с графикой, а также свободная программная среда вычислений с открытым исходным кодом в рамках проекта GNU. Язык создавался как аналогичный языку S, разработанному в Bell Labs, и является его альтернативной реализацией, хотя между языками есть существенные отличия, но в большинстве своём код на языке S работает в среде R. Изначально R был разработан сотрудниками статистического факультета Оклендского университета Россом Айхэкой (англ. Ross Ihaka) и Робертом Джентлменом (англ. Robert Gentleman) (первая буква их имён — R); язык и среда поддерживаются и развиваются организацией R Foundation.

Язык R — главный конкурент Python для тех, кто занимается статистикой и анализом данных. Его используют в социальных и экономических науках для поиска причинно-следственных связей, сравнения выборок, создания наглядных отчётов и графиков.

Язык разработали учёные факультета статистики Оклендского университета. Сначала это был внутренний инструмент, но потом его сделали доступным для всех — уж очень удачным он получился.

А специализированный язык R уверенно отвоёвывает себе место под солнцем: с 18-го места рейтинга TIOBE в 2016 году он поднялся на 8-ю строчку в январе 2021. Установить интерпретатор и рабочее окружение можно в любую современную операционную систему — MacOS, Linux, Windows.


Широко используется как статистическое программное обеспечение для анализа данных и фактически стал стандартом для статистических программ.

Язык и среда доступны под лицензией GNU GPL; распространяются в виде исходных кодов, а также откомпилированных приложений под ряд операционных систем: FreeBSD, Solaris и другие дистрибутивы Unix и Linux, Windows, macOS.

В R используется интерфейс командной строки, хотя доступны и несколько графических интерфейсов пользователя, например пакет R Commander, RKWard, RStudio, Weka, Rapid Miner, KNIME[en], а также средства интеграции в офисные пакеты.

Для удобства работы с R разработан ряд графических интерфейсов, в том числе RStudio, JGR, RKWard, SciViews-R, Statistical Lab, R Commander, Rattle, а также программный пакет Shiny.

Кроме того, в ряде текстовых и кодовых редакторов предусмотренные специальные режимы для работы с R, в частности в ConTEXT, Emacs (Emacs Speaks Statistics), jEdit, Kate, Notepad++, Syn, TextMate, Tinn-R, Vim, Bluefish, WinEdt (с пакетом RWinEdt), Gedit (с пакетом rgedit/gedit-r-plugin). Для среды разработки Eclipse существует специализированный R-плагин; доступ к функциям и среде выполнения R возможен из Python с использованием пакета RPy; работать с R можно из эконометрического пакета Gretl.

Что можно сделать с помощью R
-Обработать, очистить и преобразовать данные для исследования
-Провести статистические тесты
-Выполнить разведочный анализ
-Работать с таблицами разных форматов
-Нарисовать интерактивный график
-Создать интерактивное приложение
-Анализировать регрессионные модели

Преимущества R
Неограниченный набор функций для анализа данных — благодаря подключению библиотек.
Возможность работы с огромными таблицами и базами данных, которые не потянут программы.
Продвинутые настройки интерфейса: графический пользовательский или интерфейс командной строки.
Полностью бесплатная экосистема — компоненты распространяются бесплатно под лицензией GNU. Excel стоит 69,99 доллара в год, SPSS — 3200 долларов за бессрочную лицензию, Tableau для компаний — от 70 долларов за пользователя в месяц.
Доступен для большинства операционных систем: Windows, macOS, FreeBSD, Solaris, разных версий Unix и Linux.
Богатые возможности визуализации: можно создавать приложения, строить графики разных типов, в том числе интерактивные, а также редактировать их элементы. Например, график на основе известного датасета iris, показывающий плотность лепестков и чашелистиков в зависимости от вида ирисов.


Минусы R — относительные:

Документация и большинство источников — только на английском языке. Хотя появляется всё больше русскоязычных источников — уже есть отдельный раздел на «Хабре», а ответы на частые вопросы можно найти на Stack Overflow.
Человеку без опыта программирования и знания основ статистики будет сложно. Но достаточно освоить базовые понятия: среднее, мода, медиана, выборка, нормальное распределение. Например, по книге «Статистика и котики» В. Савельева.
Узкая сфера применения: он идеален для анализа данных, но для разработки программ не подходит. Но в этом и его сила. Настоящий UNIX-way и находка для учёных, журналистов, дата-сайентистов, аналитиков — всех, кто хочет работать с данными.

R — это не просто язык программирования, а целая инфраструктура и специализированная среда для работы с данными. В неё уже встроены многие статистические методы и варианты визуализации.
